﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Investment
{
    struct raspr
    {
        public double max;
        public double investment;
    }
    internal class InvestmentMethods
    {
        public string Path { get; set; }
        public InvestmentMethods(string path)
        {
            Path = path;
        }

        private (List<double>,List<List<double>>) reading()
        {
            int n = File.ReadAllLines(Path).Length;
            List<List<double>> income = new List<List<double>>();
            List<double> contribution = new List<double>();
            using (StreamReader reader = new StreamReader(Path))
            {
                for (int i = 0; i < n; i++)
                {
                    
                    string text = reader.ReadLine();
                    string[] mas = text.Split(new char[] {'\t'});
                    if(i == 0)
                    {
                        for(int j = 1; j < mas.Length; j++)
                        {
                            income.Add(new List<double>());
                        }
                    }

                    for (int j = 0; j < mas.Length; j++)
                    {
                        if (j == 0)
                        {
                            contribution.Add(double.Parse(mas[j]));
                        }
                        else
                        {
                            income[j-1].Add(double.Parse(mas[j])); 
                        }
                    }

                }

            }

            return (contribution, income);
        }

        private List<List<double>> copy(List<List<double>> income)
        {
            List<List<double>> income_copy = new List<List<double>>();
            for(int i = 0;i < income.Count;i++)
            {
                income_copy.Add(new List<double>());
                for (int j = 0; j < income[i].Count; j++)
                {
                    income_copy[i].Add(income[i][j]);
                }
            }
            return income_copy;
        }


        public void MainMethod()
        {
            List<List<double>> income = reading().Item2;
            List<List<double>> income_copy = copy(income);
            List<double> contribution = reading().Item1;
            double difference = contribution[1] - contribution[0];
            List<List<double>> distribution = new List<List<double>>();
            for (int i = 0; i < contribution.Count; i++)
            {
                double firstCompany = 0;
                double secondCompany = contribution[i];
                for (int j = 0; j < i + 1; j++)
                {
                    if (j == 0)
                    {
                        distribution.Add(new List<double>() { firstCompany, secondCompany });
                    }
                    else
                    {
                        firstCompany += difference;
                        secondCompany -= difference;
                        distribution.Add(new List<double>() { firstCompany, secondCompany });
                    }

                }
            }
            List<List<raspr>> timesDistribution = new List<List<raspr>>();

            bool flag = true;
            while (flag)
            {
                timesDistribution.Add(new List<raspr>());
                double max = Double.MinValue;
                double rasp = 0;
                int counter = 2;
                int add = 3;
                for (int i = 0; i < distribution.Count; i++)
                {

                    int firstRas = contribution.IndexOf(distribution[i][0]);
                    int secondRas = contribution.IndexOf(distribution[i][1]);
                    double dohod = income_copy[income_copy.Count - 2][firstRas] + income_copy[income_copy.Count - 1][secondRas];
                    if (dohod > max)
                    {
                        max = dohod;
                        rasp = distribution[i][0];
                    }
                    if (counter == i)
                    {

                        raspr r = new raspr();
                        r.max = max;
                        r.investment = rasp;

                        timesDistribution[timesDistribution.Count - 1].Add(r);
                        counter += add;
                        add++;
                        max = Double.MinValue;

                    }
                }

                income_copy.RemoveAt(income_copy.Count - 1);
                income_copy[income_copy.Count - 1][0] = 0;
                for (int i = 1; i < income_copy[income_copy.Count - 1].Count; i++)
                {
                    income_copy[income_copy.Count - 1][i] = timesDistribution[timesDistribution.Count - 1][i - 1].max;
                }
                if (income_copy.Count == 2)
                {
                    int i = (int)(distribution.Count - 1 - (contribution[contribution.Count - 1] / difference));
                    for (; i < distribution.Count; i++)
                    {

                        int firstRas = contribution.IndexOf(distribution[i][0]);
                        int secondRas = contribution.IndexOf(distribution[i][1]);
                        double dohod = income_copy[income_copy.Count - 2][firstRas] + income_copy[income_copy.Count - 1][secondRas];
                        if (dohod > max)
                        {
                            max = dohod;
                            rasp = distribution[i][0];
                        }
                    }
                    timesDistribution.Add(new List<raspr>());
                    raspr r = new raspr();
                    r.max = max;
                    r.investment = rasp;
                    timesDistribution[timesDistribution.Count - 1].Add(r);

                    flag = false;
                }

            }
            double itog;
            List<double> rezult = new List<double>();
            rezult.Add(timesDistribution[timesDistribution.Count - 1][0].investment);
            itog = rezult[rezult.Count - 1];
            int index = contribution.IndexOf(contribution[contribution.Count - 1] - rezult[rezult.Count - 1]);
            for (int i = timesDistribution.Count - 2; i >= 0; i--)
            {
                rezult.Add(timesDistribution[i][index - 1].investment);
                itog += rezult[rezult.Count - 1];
            }
            rezult.Add(contribution[contribution.Count - 1] - itog);
            double func = 0;
            for(int i = 0; i < rezult.Count; i++)
            {
                int ind = (int)(rezult[i] / difference);
                func += income[i][ind];
            }
            writing(rezult, func);


        }

        private void writing(List<double> rezult, double func)
        {
            FileStream file1 = new FileStream("rezult.txt", FileMode.OpenOrCreate);
            StreamWriter writer = new StreamWriter(file1);
            writer.Write("Распределение инвестиций: ");
            for (int i = 0; i < rezult.Count; i++)
            {
                writer.Write(rezult[i] + " ");
            }
            writer.Write('\n');
            writer.WriteLine("Полученный доход: " + func);
            writer.Close();
        }

    }
}
